// Code generated by mockery v2.42.3. DO NOT EDIT.

package mock_repository

import (
	context "context"

	config "gitlab.com/commonground/nlx/fsc-nlx/outway/domain/config"

	mock "github.com/stretchr/testify/mock"
)

// MockRepository is an autogenerated mock type for the Repository type
type MockRepository struct {
	mock.Mock
}

type MockRepository_Expecter struct {
	mock *mock.Mock
}

func (_m *MockRepository) EXPECT() *MockRepository_Expecter {
	return &MockRepository_Expecter{mock: &_m.Mock}
}

// GetServiceConnectionInfo provides a mock function with given fields: ctx, grantHash
func (_m *MockRepository) GetServiceConnectionInfo(ctx context.Context, grantHash string) (*config.ServiceConnectionInfo, error) {
	ret := _m.Called(ctx, grantHash)

	if len(ret) == 0 {
		panic("no return value specified for GetServiceConnectionInfo")
	}

	var r0 *config.ServiceConnectionInfo
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*config.ServiceConnectionInfo, error)); ok {
		return rf(ctx, grantHash)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *config.ServiceConnectionInfo); ok {
		r0 = rf(ctx, grantHash)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*config.ServiceConnectionInfo)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, grantHash)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockRepository_GetServiceConnectionInfo_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'GetServiceConnectionInfo'
type MockRepository_GetServiceConnectionInfo_Call struct {
	*mock.Call
}

// GetServiceConnectionInfo is a helper method to define mock.On call
//   - ctx context.Context
//   - grantHash string
func (_e *MockRepository_Expecter) GetServiceConnectionInfo(ctx interface{}, grantHash interface{}) *MockRepository_GetServiceConnectionInfo_Call {
	return &MockRepository_GetServiceConnectionInfo_Call{Call: _e.mock.On("GetServiceConnectionInfo", ctx, grantHash)}
}

func (_c *MockRepository_GetServiceConnectionInfo_Call) Run(run func(ctx context.Context, grantHash string)) *MockRepository_GetServiceConnectionInfo_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(string))
	})
	return _c
}

func (_c *MockRepository_GetServiceConnectionInfo_Call) Return(_a0 *config.ServiceConnectionInfo, _a1 error) *MockRepository_GetServiceConnectionInfo_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockRepository_GetServiceConnectionInfo_Call) RunAndReturn(run func(context.Context, string) (*config.ServiceConnectionInfo, error)) *MockRepository_GetServiceConnectionInfo_Call {
	_c.Call.Return(run)
	return _c
}

// GetServices provides a mock function with given fields: ctx
func (_m *MockRepository) GetServices(ctx context.Context) (config.Services, error) {
	ret := _m.Called(ctx)

	if len(ret) == 0 {
		panic("no return value specified for GetServices")
	}

	var r0 config.Services
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context) (config.Services, error)); ok {
		return rf(ctx)
	}
	if rf, ok := ret.Get(0).(func(context.Context) config.Services); ok {
		r0 = rf(ctx)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(config.Services)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context) error); ok {
		r1 = rf(ctx)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockRepository_GetServices_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'GetServices'
type MockRepository_GetServices_Call struct {
	*mock.Call
}

// GetServices is a helper method to define mock.On call
//   - ctx context.Context
func (_e *MockRepository_Expecter) GetServices(ctx interface{}) *MockRepository_GetServices_Call {
	return &MockRepository_GetServices_Call{Call: _e.mock.On("GetServices", ctx)}
}

func (_c *MockRepository_GetServices_Call) Run(run func(ctx context.Context)) *MockRepository_GetServices_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context))
	})
	return _c
}

func (_c *MockRepository_GetServices_Call) Return(_a0 config.Services, _a1 error) *MockRepository_GetServices_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockRepository_GetServices_Call) RunAndReturn(run func(context.Context) (config.Services, error)) *MockRepository_GetServices_Call {
	_c.Call.Return(run)
	return _c
}

// GetToken provides a mock function with given fields: ctx, peerID, managerAddress, grantHash
func (_m *MockRepository) GetToken(ctx context.Context, peerID string, managerAddress string, grantHash string) (string, error) {
	ret := _m.Called(ctx, peerID, managerAddress, grantHash)

	if len(ret) == 0 {
		panic("no return value specified for GetToken")
	}

	var r0 string
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string, string, string) (string, error)); ok {
		return rf(ctx, peerID, managerAddress, grantHash)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string, string, string) string); ok {
		r0 = rf(ctx, peerID, managerAddress, grantHash)
	} else {
		r0 = ret.Get(0).(string)
	}

	if rf, ok := ret.Get(1).(func(context.Context, string, string, string) error); ok {
		r1 = rf(ctx, peerID, managerAddress, grantHash)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockRepository_GetToken_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'GetToken'
type MockRepository_GetToken_Call struct {
	*mock.Call
}

// GetToken is a helper method to define mock.On call
//   - ctx context.Context
//   - peerID string
//   - managerAddress string
//   - grantHash string
func (_e *MockRepository_Expecter) GetToken(ctx interface{}, peerID interface{}, managerAddress interface{}, grantHash interface{}) *MockRepository_GetToken_Call {
	return &MockRepository_GetToken_Call{Call: _e.mock.On("GetToken", ctx, peerID, managerAddress, grantHash)}
}

func (_c *MockRepository_GetToken_Call) Run(run func(ctx context.Context, peerID string, managerAddress string, grantHash string)) *MockRepository_GetToken_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(string), args[2].(string), args[3].(string))
	})
	return _c
}

func (_c *MockRepository_GetToken_Call) Return(_a0 string, _a1 error) *MockRepository_GetToken_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockRepository_GetToken_Call) RunAndReturn(run func(context.Context, string, string, string) (string, error)) *MockRepository_GetToken_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockRepository creates a new instance of MockRepository. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockRepository(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockRepository {
	mock := &MockRepository{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
